package info.aspirecn.iov.yysj.check.info.common;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.*;
import javax.servlet.http.HttpServletResponse;

import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.iov.yysj.check.info.CheckInfo;
import info.aspirecn.iov.yysj.check.info.entity.BillResultObject;
import info.aspirecn.iov.yysj.check.info.entity.CheckInfoRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import com.netflix.zuul.context.RequestContext;
import lombok.extern.slf4j.Slf4j;
@Component
@Slf4j
public class ZuulHelper {
	@Autowired
	private ObjectMapper mapper;
	@Autowired
	Gson gson;
	@Autowired
	StringRedisTemplate stringTemplate;
	@Autowired
	Property property;
	public Boolean hasProcessFlag(RequestContext requestContext) {
        
        Boolean ret = (Boolean)requestContext.get("process");
        if( ret != null )
        {
            return ret;
        }
        else
        {
            return Boolean.FALSE;
        }
    }
	
	public void responseHandle(BillResultObject responseObject, RequestContext requestContext, boolean isContinue) throws JsonProcessingException{
		String json = mapper.writeValueAsString(responseObject);
		 requestContext.set("process", isContinue);
		 requestContext.setResponseBody(json);
		 requestContext.getResponse().setCharacterEncoding("utf-8");
		 requestContext.getResponse().setContentType("application/json");
		 requestContext.setSendZuulResponse(false);
		 requestContext.setResponseStatusCode(HttpServletResponse.SC_OK);// 返回码
	}
	//获取请求参数
	public  String getCustomBody(RequestContext requestContext) throws UnsupportedEncodingException, IOException{
		StringBuilder body = new StringBuilder();
	 	BufferedReader bufferedReader = new BufferedReader(
				new InputStreamReader(requestContext.getRequest().getInputStream(), "utf-8")); // 读取参数流
		String nextLine = bufferedReader.readLine();
		while (nextLine != null) {
		    body.append(nextLine);
			nextLine = bufferedReader.readLine();
		}
		String bodyStr = body.toString();
		Map map = gson.fromJson(bodyStr, Map.class);
		Object customBodyObject = map.get("customBody");
		String customBody = mapper.writeValueAsString(customBodyObject);
		return customBody;
	}
	//拆分运单map
	public static  String divYunDan(String customBody) throws JsonProcessingException {
		ObjectMapper objectMapper=new ObjectMapper();


			Map <String,Object> resultMap = new HashMap<String,Object>();
			Map<String, String> map = objectMapper.readValue(customBody, Map.class);
			handle(map,resultMap);
			return objectMapper.writeValueAsString(resultMap);


	}
	public static void handle(Map map,Map<String,Object> resultMap){
		Set<Map.Entry<String,String>> set = map.entrySet();


		for(Map.Entry<String,String> entry :set){
			String key =entry.getKey();
			Object value = entry.getValue();
			String upperKey="";
			if("vin".equals(key)){
				upperKey="VIN";
			}else{
				upperKey = key.substring(0,1).toUpperCase()+key.substring(1);
			}
			if(value instanceof LinkedHashMap){
				Map hashMap = (Map)value;
				Map<String,Object> resultHashMap = new HashMap<String,Object>();
				handle(hashMap,resultHashMap);
				resultMap.put(upperKey,resultHashMap);
			}else if(value instanceof String){
				resultMap.put(upperKey,value);
			}else if(value instanceof ArrayList){
				List<Object> list = new ArrayList<Object>();
				for(int i=0;i<((List) value).size();i++){
					Object listValue = ((List) value).get(i);
					if(listValue instanceof LinkedHashMap){
						Map linkMap = (Map)listValue;
						Map<String,Object> resultHashMap = new HashMap<String,Object>();
						 handle(linkMap,resultHashMap);
						 list.add(resultHashMap);
					}else  if(value instanceof String){
						resultMap.put(upperKey,value);
						list.add(value);
					}
					resultMap.put(upperKey,list);
				}
			}
		}
	}
	//请求参数查询解决
	public  String queryParam(String url,Map<String, String>  map){
		String result = null;
		try{
			CheckInfoRequest checkInfoRequest =new CheckInfoRequest();
			if(Constants.RequestUrl.DRIVERURL.getValue().equals(url)){
				checkInfoRequest.setPerson_name(map.get(Constants.driver_driverNamer));
				checkInfoRequest.setPerson_driverNo(map.get(Constants.driver_driverLicenseNumber));
				checkInfoRequest.setPerson_QualificationCertificate(map.get(Constants.driver_qualificationCertificate));
			}else if(Constants.RequestUrl.CARURL.getValue().equals(url)){
				checkInfoRequest.setCar_vehicleNumber(map.get(Constants.car_vehicleNumber));
				checkInfoRequest.setCar_vehiclePlateColorCode(map.get(Constants.car_vehiclePlateColorCode));
			}else if(Constants.RequestUrl.BILLWAYURL.getValue().equals(url)){
				checkInfoRequest.setBill_shippingNoteNumber(map.get("shippingNoteNumber"));
				Object vehicleInfo = map.get("vehicleInfo");
				if(vehicleInfo !=null && vehicleInfo instanceof  LinkedHashMap){
					Map vehicleInfoMap = (Map)vehicleInfo;
					String vehicleNumber=(String)vehicleInfoMap.get("vehicleNumber");
					checkInfoRequest.setBill_vehicleNumber(vehicleNumber);
				}

			}
			result = mapper.writeValueAsString(checkInfoRequest);
		} catch (IOException e) {
			log.error("Exception:{}",e);
		}
		return result;
	}
	public  int getType(String url){
			if(Constants.RequestUrl.DRIVERURL.getValue().equals(url)){
				return 2;
			}else if(Constants.RequestUrl.CARURL.getValue().equals(url)){
				return 1;
			}else if(Constants.RequestUrl.BILLWAYURL.getValue().equals(url)){
				return 3;
			}else if(Constants.OtherRquestUrl.LIVINGURL.getValue().equals(url)){
				return 4;
			}else if(Constants.OtherRquestUrl.IDLENTITYVERIFICATION.getValue().equals(url)){
				return 5;
			}

		return 0;
	}
	//请求参数透传参数
	/*public  String tcParam(String url,String productId,Map<String, String>  map){
		String result = null;
		try{
			CheckInfo checkInfo =new CheckInfo();
			//Map<String, String>  map= mapper.readValue(customBody, Map.class);
			Map<String, String>  tcCustomMap = new HashMap<String,String>();
			if("/info_check/driverInfo.do".equals(url)||"/info_check/carInfo.do".equals(url)){

				String paramStr = property.getCarMap().get(productId);
				String[] params = paramStr.split("-");
				for(String param:params){
					tcCustomMap.put(param,map.get(param));
				}
				return mapper.writeValueAsString(tcCustomMap);
			}else if("/info_check/waybill.do".equals(url)){
				checkInfo.setBill_shippingNoteNumber(map.get("ShippingNoteNumber"));
				Object vehicleInfo = map.get("VehicleInfo");
				if(vehicleInfo !=null && vehicleInfo instanceof  LinkedHashMap){
					Map vehicleInfoMap = (Map)vehicleInfo;
					String vehicleNumber=(String)vehicleInfoMap.get("VehicleNumber");
					checkInfo.setBill_vehicleNumber(vehicleNumber);
				}

			}
			result = mapper.writeValueAsString(checkInfo);
		} catch (IOException e) {
			log.error("Exception:{}",e);
		}
		return result;
	}*/



}

